#! /usr/bin/perl -w

#
# Operazioni preliminari.
#
open(INPUT,$ARGV[0]) || die "Problemi con il file $ARGV[0]";
$nome = $ARGV[1] || die "Nome da allocare assente"; 

#
# Primo ciclo di lettura, <INPUT> viene caricato in una matrice.
#
while (<INPUT>)
{
	#
	# Rimuove il primo '|' a inizio rigo
	#
    s[^\|][];
    #
    # Ciclo che rimuove l'ultimo '|' e tutto ci che lo segue.
    #
    $a = ' ';
    $a = chop while ($a && $a ne '|'); 
 	#
 	# Splitta $_ per '|'. Ogni pezzetto  poi assegnato in un ciclo foreach a $matrice[$i][$j++].
 	# Si ricordi che split(/\!/) viene valutata UNA SOLA VOLTA a inizio ciclo, dunque si pu
 	# usare $_ nel ciclo pi interno senza problemi.
 	#
 	$matrice[$i][$j++] = $_ foreach(split /\|/);
 	#
 	# Il codice precedente equivale a:
 	# 
 	# @temp = split(/\|/,$_);
 	# foreach(@temp) 
 	# {
 	#	$matrice[$i][$j++] = $_;
 	# } 
 	#
	$i++; $j = 0;
}
close INPUT;

#
# Ricerca di un quadrato 3x3 libero.
#

#
# Il primo for + esterno va da 0 a @matrice. Si ricordi che una matrice  in realt
# un array di array ($matrice[$0] = prima striscia, $matrice[1] = seconda striscia... ecc.).
#
for ($i = 0; $i < @matrice; $i++)
{
    #
    # Notazione un po' particolare serve a dire di interpretare $matrice[$i] come un array
    # e non come uno scalare. Si pu evitare con un programma leggermente pi lungo.
    # 
	for ($j = 0; $j < @{$matrice[$i]}; $j++)
    {
    	if (libero($i,$j))
        {
        	$matrice[$i][$j] = $nome;
        	$found = 1;
        	#
        	# Termina il for pi interno se trovato posto
        	#
        	last;
        } 
    }
    #
    # Termina il for pi esterno se il ciclo pi interno  terminato.
    #
    last if $found;
}

#
# Riscrive la nuova matrice con il nuovo valore.
#
if ($found)
{
	open(OUTPUT,">$ARGV[0]") || die "Impossibile aprire $ARGV[0] in scrittura";
    for ($i = 0; $i < @matrice; $i++)
    {
	    print OUTPUT "|";
	    for ($j = 0; $j < @{$matrice[$i]}; $j++)
	    {
	    	print OUTPUT $matrice[$i][$j]."|";
	    }
	    print OUTPUT "\n";
    }
    close OUTPUT;		
}
else { die "Nessun posto trovato per $nome"; }




sub libero
{
  #
  # la keyword 'my' serve a dichiarare $i e $j come locali a questa subroutine. 
  #
   my ($i, $j) = ( $_[0], $_[1] );
   
   #
   # Ritorna true se tutte le nove celle (la centrale pi le otto adiacenti)
   # non contengono testo (dunque contengono spazio oppure sono indefinite)
   #
   return $matrice[$i-1][$j-1] !~ /\w+/ && 
          $matrice[$i-1][$j] !~ /\w+/ &&
          $matrice[$i-1][$j+1] !~ /\w+/ &&
          $matrice[$i][$j-1] !~ /\w+/ &&
          $matrice[$i][$j] !~ /\w+/ &&
 		  $matrice[$i][$j+1] !~ /\w+/ &&
 		  $matrice[$i+1][$j-1] !~ /\w+/ &&
 		  $matrice[$i+1][$j] !~ /\w+/ &&
 		  $matrice[$i+1][$j+1] !~ /\w+/;
   #
   # L'istruzione precedente  equivalente a 
   #
   # for($r = -1; $r <= 1; $r++ )
   # {
   #   for($c = -1; $c <= 1; $c++ )
   #	   {
   #	   	   return 0 if $matrice[$i+$r][$j+$c] =~ /\w+/;
   #	   }
   # }
   # return 1;
}