#include <JTC\jtc.h>
#define N 4

#include "macinaPrimi.h"
#include <math.h>
#include <iostream.h>

class Macinatore : public JTCThread
{
    friend class MacinaPrimi;
	MacinaPrimi* m;
	int min;
	int max;
	Macinatore(MacinaPrimi* m, int min, int max)
	{
		this->m = m;
		this->min = min;
		this->max = max;
	}
	virtual void run()
	{
		for(int i = min; i <= max; i++)
			if (m->isPrime(i)) m->incPrimiCorrenti();
		m->done();
	}
};

int MacinaPrimi::calcolaPrimi(int min, int max)
	{
		int quota = (max-min)/N;
		primiCorrenti = 0;
		threadFiniti = 0;
        //
		// Strategia: assegnare una quota di numeri primi ad ogni thread DALL'INIZIO
		//
		for(int i=0; i < N-1; i++)
		{	
			macinatori[i] = new Macinatore(this, min+i*quota, min+(i+1)*quota-1);
			macinatori[i]->start();
		}
		//
		// All'ultimo thread vengono assegnati tutti i numeri restanti fino a max.
		//
		macinatori[N-1] = new Macinatore(this, min+(N-2)*quota , max);
		macinatori[N-1]->start();
		waitForCompletion();
		return primiCorrenti;
	}
bool MacinaPrimi::isPrime(int n)
	{
		if (n == 2) return true;
		if (n % 2 == 0) return false;
//
//  Verifica se n  primo, provando tutti i divisori da 3 a radice di n. 
//  (inutile provare quelli superiori a radice di n, pensateci).
//
		for (int i = 3; i <= floor(sqrt(n)); i += 2)
			if (n % i == 0) return false;
	    return true;
	}
//
// Attenzione! La variabile primiCorrenti va aggiornata in mutuaesclusione.
//
    void MacinaPrimi::incPrimiCorrenti()
	{
		JTCSynchronized sync(*this);
		primiCorrenti++;
	}
// Invocato da ogni thread per segnalare di aver finito la sua fetta. 
// L'ultimo thread fa notify per svegliare la calcolaPrimi che dovrebbe
// trovarsi in stato di wait.
	void MacinaPrimi::done()
	{
		JTCSynchronized sync(*this);
		threadFiniti++;
		if (threadFiniti == N) notify();
	}
//
// Invocata da calcolaPrimi per attendere la terminazione di tutti i
// thread.
//

    void MacinaPrimi::waitForCompletion()
	{
		JTCSynchronized sync(*this);
		if (threadFiniti < N) wait();
	}


void main()
{
    JTCInitialize init;
	MacinaPrimi m;
    cout << m.calcolaPrimi(1,50000) << endl;
}